<?php
function wpaa_chart_overview() {
    global $wpdb;

    $table_name = $wpdb->prefix . 'wpsa';

    // Last "N" days graph
    $gdays = get_option( 'wpaa_daysinoverviewgraph' );

    if ( (int) $gdays === 0 ) {
        $gdays = 20;
    }

    // JSON array for ChartJS
    $query_stats = [
        'date'      => [],
        'visitors'  => [],
        'pageviews' => [],
    ];
    //

    // Y
    for ( $gg = $gdays - 1; $gg >= 0; $gg-- ) {
        $date_full = gmdate( 'Ymd', current_time( 'timestamp' ) - 86400 * $gg );

        $query_stats['date'][] = gmdate( 'd', current_time( 'timestamp' ) - 86400 * $gg ) . ' ' . gmdate( 'M', current_time( 'timestamp' ) - 86400 * $gg );

        // Total visitors
        $qry_visitors = $wpdb->get_row( "SELECT COUNT(DISTINCT ip) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "'" );
        $query_stats['visitors'][] = $qry_visitors->total; // ChartJS

        $qry_pageviews = $wpdb->get_row( "SELECT COUNT(FROM_UNIXTIME(timestamp, '%Y%m%d')) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "'" );
        $query_stats['pageviews'][] = $qry_pageviews->total; // ChartJS

        $qry_sessions = $wpdb->get_row( "SELECT COUNT(DISTINCT(session_id)) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "' AND session_id IS NOT NULL;" );
        $query_stats['sessions'][] = $qry_sessions->total; // ChartJS

        // @todo Add bounce rate
        // @url  https://usefulangle.com/post/335/javascript-implement-analytics-page-views
    }

    $date      = implode( ',', $query_stats['date'] );
    $users     = implode( ',', $query_stats['visitors'] );
    $pageviews = implode( ',', $query_stats['pageviews'] );
    $sessions  = implode( ',', $query_stats['sessions'] );

    echo '<canvas id="myChart" style="width:100%;height:400px" data-labels="' . $date . '" data-users="' . $users . '" data-pageviews="' . $pageviews . '" data-sessions="' . $sessions . '"></canvas>';

    wp_die();
}

function wpaa_chart_dashboard() {
    global $wpdb;

    $table_name = $wpdb->prefix . 'wpsa';

    // Last "N" days graph
    $gdays = 15;

    // JSON array for ChartJS
    $query_stats = [
        'date'      => [],
        'visitors'  => [],
        'pageviews' => [],
    ];
    //

    // Y
    for ( $gg = $gdays - 1; $gg >= 0; $gg-- ) {
        $date_full = gmdate( 'Ymd', current_time( 'timestamp' ) - 86400 * $gg );

        $query_stats['date'][] = gmdate( 'd', current_time( 'timestamp' ) - 86400 * $gg ) . ' ' . gmdate( 'M', current_time( 'timestamp' ) - 86400 * $gg );

        // Total visitors
        $qry_visitors = $wpdb->get_row( "SELECT COUNT(DISTINCT ip) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "'" );
        $query_stats['visitors'][] = $qry_visitors->total; // ChartJS

        $qry_pageviews = $wpdb->get_row( "SELECT COUNT(FROM_UNIXTIME(timestamp, '%Y%m%d')) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "'" );
        $query_stats['pageviews'][] = $qry_pageviews->total; // ChartJS

        $qry_sessions = $wpdb->get_row( "SELECT COUNT(DISTINCT(session_id)) AS total FROM $table_name WHERE FROM_UNIXTIME(timestamp, '%Y%m%d') = '" . $date_full . "' AND session_id IS NOT NULL;" );
        $query_stats['sessions'][] = $qry_sessions->total; // ChartJS

        // @todo Add bounce rate
        // @url  https://usefulangle.com/post/335/javascript-implement-analytics-page-views
    }

    $date      = implode( ',', $query_stats['date'] );
    $users     = implode( ',', $query_stats['visitors'] );
    $pageviews = implode( ',', $query_stats['pageviews'] );
    $sessions  = implode( ',', $query_stats['sessions'] );

    echo '<canvas id="myChart" style="width:100%;height:200px" data-labels="' . $date . '" data-users="' . $users . '" data-pageviews="' . $pageviews . '" data-sessions="' . $sessions . '"></canvas>';

    wp_die();
}
