<?php
function wpaa_meta_box() {
    $post_types = get_post_types();

    foreach ( $post_types as $post_type ) {
        add_meta_box(
            'Meta_box_ID',
            'Active Analytics',
            'wpaa_meta_box_display',
            $post_type
        );
    }
}

function wpaa_meta_box_display( $post ) {
    $count_key = get_option( 'wpaa_pageviews_key' );
    $count     = (int) get_post_meta( $post->ID, $count_key, true );

    echo number_format( $count ) . __( ' pageviews', 'active-analytics' );
}

if ( (int) get_option( 'wpaa_collect_post_views' ) === 1 ) {
    add_action( 'add_meta_boxes', 'wpaa_meta_box' );
}

function wpaa_generate_post_select( $select_id, $post_type, $selected = 0 ) {
    $post_type_object = get_post_type_object( $post_type );
    $label            = $post_type_object->label;
    $out              = '';

    $posts = get_posts(
        [
            'post_type'        => $post_type,
            'post_status'      => 'publish',
            'orderby'          => 'title',
            'order'            => 'ASC',
            'suppress_filters' => false,
            'posts_per_page'   => -1,
        ]
    );

    $out .= '<select name="' . $select_id . '" id="' . $select_id . '">
        <option value="0">All ' . $label . ' </option>';

        foreach ( $posts as $post ) {
            $out .= '<option value="' . $post->ID . '"' . ( (int) $selected === (int) $post->ID ? ' selected' : '' ) . '>' . $post->post_title . '</option>';
        }

    $out .= '</select>';

    return $out;
}
