<?php
function wpaa_action_views() {
    echo '<h2>' . __( 'Pageviews', 'active-analytics' ) . '</h2>';

    echo '<p>' . __( 'This is an overview of the top posts and pages based on a pageview counter.', 'active-analytics' ) . '</p>';

    /**
     * Top pages
     */
    echo '<h2>' . __( 'Top Pages' ) . '</h2>';

    $wpaa_pageviews_key = get_option( 'wpaa_pageviews_key' );

    $query_args_meta = [
        'posts_per_page'         => 500,
        'post_type'              => [ 'page' ],
        'post_status'            => 'publish',
        'suppress_filters'       => true,
        'ignore_sticky_posts'    => true,
        'has_password'           => false,
        'cache_results'          => false,
        'update_post_meta_cache' => false,
        'update_post_term_cache' => false,
        'fields'                 => 'ids',
    ];

    $query_args_meta['orderby']  = 'meta_value_num';
    $query_args_meta['meta_key'] = $wpaa_pageviews_key;
    $query_args_meta['order']    = 'DESC';

    $pageview_query = new WP_Query( $query_args_meta );

    echo '<table width="100%" cellpadding="8" cellspacing="0" class="top-pages-table--all">
        <thead>
            <tr>
                <th>URL</th>
                <th>Pageviews</th>
            </tr>
        </thead>
        <tbody>';

        foreach ( $pageview_query->posts as $page_id ) {
            echo '<tr>
                <td><a href="' . get_permalink( $page_id ) . '">' . get_permalink( $page_id ) . '</a></td>
                <td>' . number_format( get_post_meta( $page_id, $wpaa_pageviews_key, true ) ) . '</td>';
            echo '</tr>';
        }

    echo '</table>';
    //

    /**
     * Top posts
     */
    echo '<h2>' . __( 'Top Posts' ) . '</h2>';

    $wpaa_pageviews_key = get_option( 'wpaa_pageviews_key' );

    $query_args_meta = [
        'posts_per_page'         => 500,
        'post_type'              => [ 'post' ],
        'post_status'            => 'publish',
        'suppress_filters'       => true,
        'ignore_sticky_posts'    => true,
        'has_password'           => false,
        'cache_results'          => false,
        'update_post_meta_cache' => false,
        'update_post_term_cache' => false,
        'fields'                 => 'ids',
    ];

    $query_args_meta['orderby']  = 'meta_value_num';
    $query_args_meta['meta_key'] = $wpaa_pageviews_key;
    $query_args_meta['order']    = 'DESC';

    $pageview_query = new WP_Query( $query_args_meta );

    echo '<table width="100%" cellpadding="8" cellspacing="0" class="top-posts-table--all">
        <thead>
            <tr>
                <th>URL</th>
                <th>Pageviews</th>
            </tr>
        </thead>
        <tbody>';

        foreach ( $pageview_query->posts as $post_id ) {
            echo '<tr>
                <td><a href="' . get_permalink( $post_id ) . '">' . get_permalink( $post_id ) . '</a></td>
                <td>' . number_format( get_post_meta( $post_id, $wpaa_pageviews_key, true ) ) . '</td>';
            echo '</tr>';
        }

    echo '</table>';
}
